
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>企业级SaaS产品自动化测试实践 / iVAN</title>

    <meta name="description" content="企业级SaaS产品自动化测试实践 项目背景 奥博杰天中国测试团队负责一套云端人力资源管理产品的自动化测试,产品简称WHMC (Workforce Management and HCM Could Solution ). 该产品帮助大型企业管理员工考勤.排班优化,以及缺勤等复杂业务逻辑.它的客户包含制造商.零售商.医疗机构.服务机构.交通运输和物流等全球数千家各种规模机构.由于业务复杂,WHMC被拆分成15个组件,每个组件配备10-20人的研发团队. 研发团队以项目为单位分布在美国,加拿大,印度和中国多个不同的城市.WHMC作为一">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">企业级SaaS产品自动化测试实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>项目背景</strong></p>
<p>奥博杰天中国测试团队负责一套云端人力资源管理产品的自动化测试，产品简称WHMC (Workforce Management and HCM Could Solution )。 该产品帮助大型企业管理员工考勤、排班优化，以及缺勤等复杂业务逻辑。它的客户包含制造商、零售商、医疗机构、服务机构、交通运输和物流等全球数千家各种规模机构。由于业务复杂，WHMC被拆分成15个组件，每个组件配备10-20人的研发团队。 研发团队以项目为单位分布在美国，加拿大，印度和中国多个不同的城市。WHMC作为一套SaaS云端解决方案，支持客户按月购买服务， 同时也支持整套解决方案驻场部署在客户的机房内。该产品在研发上有以下几个特点：</p>
<p>作为企业级SaaS，产品的功能组件多、集成和测试难度大。</p>
<p>国际化特征明显，研发团队分布全球，沟通交流不便。</p>
<p>产品迭代更新快，每个研发团队都有自己的进度，测试团队无法控制研发团队的工作安排。</p>
<p><strong>面临的挑战</strong></p>
<p>保证自动化测试用例集可持续运行是企业级SaaS产品进行持续集成和自动化部署(CI/CD)、实现敏捷开发的核心。这一挑战由奥博杰天的测试团队来担当。我们的测试团队虽然之前做过很多国外大型项目的自动化测试，但是对测试功能点多、项目干系人分散、交付质量要求又高的企业级SaaS还是第一次碰到。用之前的项目经验去实施项目碰到了不少挑战，主要集中在以下三方面：</p>
<p><strong>测试技术的挑战</strong></p>
<p>自动化测试用例集分为UI 测试, API 测试, 和混合场景测试。我们使用TestNG (版本6.8.8)、Selenium (版本2.53.0) 的WebDriver、REST-Assured(版本2.9.0)作为测试框架的核心工具。开发完成的自动化测试用例上传到Git仓库进行版本管理，由Jenkins进行CI/CD。测试用例生命周期及测试结果通过惠普的ALM (Application Lifecycle Management) 进行管理。 整体测试框架如下图：</p>
<p><a href="http://s1.51cto.com/wyfs02/M00/04/BA/wKiom1mkzAGjIE_4AACA4kc1asw226.jpg-wh_651x-s_1619534301.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvMDQvQkEvd0tpb20xbWt6QUdqSUVfNEFBQ0E0a2MxYXN3MjI2LmpwZy13aF82NTF4LXNfMTYxOTUzNDMwMS5qcGc=.jpg"></a></p>
<p>其中开发和执行UI测试用例有两个技术难点：</p>
<p>一，Selenium判断异步加载的网页元素是否完成和如何定位网页元素。</p>
<p>这是Selenium 的WebDriver进行UI测试的经典技术问题。WHMC的很多网页数据是通过Angular JS异步加载的，测试用例有时很难判断待检查网页元素是否装载完毕，造成超时或执行失败。例如，在计算工资的页面，我们需要等员工的工时加载完然后点击“计算”按钮来计算应付工资。由于工时的表格会动态刷新，则可能计算错误。</p>
<p>还有就是定位网页元素，我们使用XPath定位，最常使用的是网页元素的属性值定位元素实例，例如div标签的ID、 img标签的href，input标签的type等属性值。但是这些属性在新版本中可能变化，造成查询条件不稳定。</p>
<p>二，SaaS模式下的多租户测试。</p>
<p>SaaS产品不同租户能使用的功能、 API限制、和数据隔离等方式等都不完全相同，多租户测试场景有别于传统自动化测试项目。</p>
<p><strong>产品更新快带来的挑战</strong></p>
<p>WHMC的 15个组件都有自己的开发计划，开发团队没有及时通知到测试团队，测试团队也很难去控制这些变化。组件发生变化后，其API文档更新不及时或非常有限，很多变化的接口只有API的定义没有参数说明，测试团队在理解和修改API测试用例时遇到很大麻烦。</p>
<p>另外，因为测试框架是和测试用例开发同步进行的，测试框架发生的变化也对测试造成影响。测试框架新增了功能，意味着需要对已开发的测试用例进行更新。 频繁更新的测试框架，对发现测试用例失败的原因也带来新的不确定因素。</p>
<p><strong>多团队跨国沟通的挑战</strong></p>
<p>由于研发团队分散在不同的国家，项目的测试流程和沟通流程都存在不足。如图：</p>
<p><a href="http://s3.51cto.com/wyfs02/M02/A3/6B/wKioL1mky_rQpBdkAACw6-z2KZc965.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvQTMvNkIvd0tpb0wxbWt5X3JRcEJka0FBQ3c2LXoyS1pjOTY1LmpwZw==.jpg"></a></p>
<p>测试用例的需求沟通完全通过ALM(Application Lifecycle Management)获取。一些测试用例需求都写得比较模糊，测试团队需要花费很长时间和各组件负责人在ALM系统中来回澄清细节。</p>
<p>由于研发团队都在国外，我们很难得到关于产品的技术支持。在测试用例开发过程中，一些测试用例执行失败的原因需要技术团队确认，只能通过邮件，对方回应不及时。</p>
<p>开发完测试用例，需要需求方review并接收。需求方确认不及时造成大量已完成的测试用例停留在待提交状态不能提交到Git进行代码管理，大量积压的测试用例产生版本冲突。</p>
<p>项目从2017年1月开始启动，经过3个月的实施，上诉问题带来的结果是每次回归的通过率徘徊在40-50%;测试用例的产出效率很低，近40人的团队每天只能产出平均1个合格的自动化测试用例;因为得不到研发团队的支持和理解，测试团队士气低落，内部弥漫着失败的气息。</p>
<p><strong>应对策略</strong></p>
<p>测试团队意识到按照现有的流程再继续下去是行不通的，于是在4月初果断停止了所有进行中的任务，商量应对方法。 在总结了前述的各种的挑战后， 提出了如下应对策略：</p>
<p>测试框架对常见的测试难点进行封装</p>
<p>对于异步数据加载问题，我们将问题分为不同的场景，提供一个示例来描述问题的细节以及我们如何处理它的当前方式。 同时负责测试框架的小组系统地了解这些场景，并封装成标准方法，并为每个场景设置最大延迟时间，如果到时不返回期望值，则抛出异常。</p>
<p>对于Web元素定位器问题，我们列出典型的情况，并与测试框架小组和国外各组件研发团队合作，将稳定的查询条件封装成一个明确的查找方法。测试人员调用统一的方法进行测试。</p>
<p><strong>加强配置管理</strong></p>
<p>包括：正确使用git工具和提交流程;使用JIRA配合AML对需求进行管理;测试团队内部代码审查等。加强配置管理对于解决SaaS产品更新快这一挑战非常有效。关于配置管理业界讨论得比较多我就不详细展开，只重点强调一下对于测试数据集的配置管理。</p>
<p>我们的测试数据集来源有两部分:</p>
<p>运行整套测试用例集之前通过工具进行初始化填充。</p>
<p>测试用例内自行管理的测试数据。</p>
<p>因为之前关于如何维护测试数据集的定义是模糊的，在运行UI测试和API测试用例时都会对这两部分数据集发生CRUD操作，造成了我们对于上述测试数据集的完整性无法保证。</p>
<p>针对这个情况， 我们加强了对数据集的配置管理，要求测试团队应严格遵循以下规则：</p>
<p>将初始化测试数据视为只读。</p>
<p>如果必须更改初始化测试数据，我们应该在测试用例退出之前改回原来的值。</p>
<p>将测试用例自己管理的数据视为例外情况，单独管理这些测试用例。</p>
<p>优化测试开发流程和团队沟通流程</p>
<p>在新的沟通流程中(如图)，我们主要做了以下改进：</p>
<p><a href="http://s1.51cto.com/wyfs02/M01/04/BA/wKiom1mkzBrw_IoUAAEJhxFUppg750.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMDQvQkEvd0tpb20xbWt6QnJ3X0lvVUFBRUpoeEZVcHBnNzUwLmpwZw==.jpg"></a></p>
<p>和每个研发团队指定点对点的联系人，建立更紧密的联系，获得必要的技术支持。</p>
<p>在Git中增加Accept分支，测试用例开发完成后在测试团队内部进行review，通过后提交到Git的Accept分支，研发团队每周定期review，接收开发好的测试用例并Merge到Main分支用于生产。</p>
<p><strong>实施过程</strong></p>
<p>从4月开始，我们按计划进行了为期4周改变，具体的做法有：</p>
<p>一，加强例框架研解决疑难技术点。例如在网页上查找employee元素，如果employee元素不在屏幕内，这时定位就会报错。 开发团队使用WebDriver JavaScriptExecutor的executeScript方法进行滚屏操作，很好的解决了这一问题。现在只需要调用getEmployeeNameDiv()方法，传入employeeName，就可返回要查找的employee元素：</p>
<p><a href="http://s1.51cto.com/wyfs02/M01/A3/6B/wKioL1mkzKyQcFDoAAD5Cvrf70E307.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDEvQTMvNkIvd0tpb0wxbWt6S3lRY0ZEb0FBRDVDdnJmNzBFMzA3LmpwZw==.jpg"></a></p>
<p>二，采用数据驱动测试的方法解决多租户测试需求。使用CSV来管理不同的测试数据集，只需装载一次测试数据文件，就可使用不同数据集多次执行测试用例，简化了用例开发量。例如切换租户只需要执行如下代码：</p>
<p><a href="http://s4.51cto.com/wyfs02/M02/A3/6B/wKioL1mkzLvThEifAAB1OINNfr0984.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvQTMvNkIvd0tpb0wxbWt6THZUaEVpZkFBQjFPSU5OZnIwOTg0LmpwZw==.jpg"></a></p>
<p>三，增派架构师参与到测试框架设计工作中，处理诸如异步数据加载等技术挑战， 同时指导测试数据管理，验证方法抽象和经验总结。</p>
<p>四，重新设计测试开发流程，增加架构师或业务分析师对测试用例的业务流程进行Review， 测试用例在本地的CI/CD环境进行daily run。并将新的流程对测试团队进行培训。</p>
<p>五，对测试人员进行技能培训，例如：Git使用，测试数据管理，与异步数据加载相关的Web元素的最佳做法，和代码审查清单等。</p>
<p>六，派专人出差到国外和各个组件团队面对面沟通，就产品，API以及疑难的测试需求进行了深入的沟通。指定一对一的联络人，加快沟通的响应速度。</p>
<p>七，针对我们之前开发的623个测试用例进行了重构。</p>
<p>经过上述改变，测试用例集回归通过率从4月底的50%提升到了80%。未通过的用例进行人工维护更新。大部分是系统更新引起的变化，一次性调整测试框架就能解决大部分。新的测试策略大大提高了CI/CD的可重用性，做到了SaaS产品自动化测试用例的高可用性。</p>
<p><strong>总结</strong></p>
<p>对于企业级SaaS来说，在自动化测试领域会有如下新挑战：</p>
<p>除了页面自动化测试的技术挑战，还要考虑SaaS产品多租户对测试用例设计带来的挑战。</p>
<p>SaaS产品迭代周期快， 对自动化用例的开发效率，用例的通过率都带来很大挑战。</p>
<p>企业级SaaS产品研发团队经常跨地域的特点，给处在不同地域的技术团队带来更大的沟通挑战。</p>
<p>奥博杰天中国测试团队在实施WHMC的自动化测试项目中得到的企业级SaaS产品最佳实践是：</p>
<p>基于成熟第三方测试软件开发适合产品需要的自动化测试框架，封装测试中遇到的疑难技术点，例如网页元素定位和判断异步加载成功。</p>
<p>采用数据驱动测试来应对多租户的挑战。</p>
<p>配备经验丰富的架构师参与测试框架设计，关键问题解决和经验总结。</p>
<p>加强配置管理，有效应对产品更新快的挑战。特别是测试数据集的管理，对于初始测试数据集保持只读;如果必须更改初始化数据，需要在用例退出时恢复原值;特殊的测试数据单独管理。</p>
<p>加强测试团队和技术团队的沟通，建立必要的跨团队沟通流程，得到研发团队的技术支持。</p>
<p>多地办公的团队有必要指定一对一联系人，肉身出差对于跨国团队沟通是最有效的办法。   </p>
<p>本文作者：李祎</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 22:52:30</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/saas/" title="SaaS">SaaS</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/api/" title="api">api</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%8a%a8%e5%8c%96%e6%b5%8b%e8%af%95/" title="自动化测试">自动化测试</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>企业级SaaS产品自动化测试实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVPy3b.html" rel="bookmark">DockOne微信分享（七十九）：基于容器技术构建企业级PaaS云平台实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是DockOne微信分享(七十九):基于容器技术构建企业级PaaS云平台实践[编者的话]企业级容器化PaaS平台旨在为企业应用提供底层支撑能力,覆盖应用开发.应用交付.上线运维等环节,包括代码的管理.持续集成.自动化测试.交付物管理.应用托管.中间件服务.自动化运维.监控报警.日志处理等,本次分享主要介绍基于容器技术构建PaaS平台所采用的相关技术.涉及的核心功能模块以及相关方案. 为满足以上需求,MoPaaS企业版基于Cloud Foundry及Kubernetes等开源技术框架和智能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjZx0M.html" rel="bookmark">资本寒冬和流量红利穷尽的大环境下，SaaS产品将何去何从？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中国云计算产业最具影响力的盛会之一--2016杭州云栖大会(https://yunqi.aliyun.com/)将在云栖小镇召开.连续举办七届的云栖大会一直是业界了解阿里云计算生态发展和应用趋势.体验前沿技术和产品的最佳平台,来自海内外的上万名开发者.创业者聚集于此,分享着他们对云计算的思考与实践经验.7年来,从产品发布到行业解决方案展示,从关注技术到技术与服务并重,从单一的客户到生态全景的展现,大会的核心内容一直在&quot;进化&quot;,而2016年杭州云栖大会,则以&quot;飞天･进化&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Ml0408M.html" rel="bookmark">从0到1搭建SaaS产品运营体系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从0到1搭建SaaS产品运营体系 责任编辑:editor005 作者:GrowingIO |  2016-09-20 15:11:13 本文摘自:36kr   本文作者:揭发,GrowingIO 业务增长负责人.揭发曾任职 Cisco, Criteo 等公司,具有丰富的 SaaS .电商.在线旅游行业数据分析和解决方案经验.原文发于GrowingIO技术博客和公众号,授权36氪转载. 如果说2015年是SaaS的元年,那么2016年就是SaaS的爆发年!经过了一年多的爆发式发展,处在风口的Saa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4NW0YM.html" rel="bookmark">DockOne微信分享（一一八）：容器技术在企业级服务里的实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是DockOne微信分享(一一八):容器技术在企业级服务里的实践[编者的话]邻盛在做面向中小微企业做服务的时候, 实际遇到很多情况, 比如对方IT基础过于薄弱, 比如基础设施过于简陋, 比如产品要解决行业需求, 企业个性需求等等,经过几年积累目前摸索出了一套完整的产品方案.目前产品是以容器为核心的一套完整的PaaS平台+全新的微服务架构+底层能力构成的完整解决方案, 目前也进入到了几家传统大型制造企业协助他们完成新一代的信息升级. [深圳站|3天烧脑式Kubernetes训练营]培训内容			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7W0xp.html" rel="bookmark">263企业通信：做企业级SaaS行业最专注的服务者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着互联网+的深入发展,企业纷纷加快信息化建设的步伐,传统的办公模式及沟通方式已难以适应互联网时代企业内部高效率.多维度.多交叉的沟通需求,云通信的到来堪称通信困局下企业的福音.据iResearch数据显示,去年中国企业云服务市场规模超500亿元,今年全球SaaS市场预计增速将超过20%,在未来几年仍将保持约30%的年复合增长率. 263企业通信作为国内企业SaaS的龙头.领先的企业通信协作服务提供商,多年来深耕企业通信服务领域,在产品.研发.运营上形成了企业邮箱.企业网盘.电话会议.网络会议.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MydrREb.html" rel="bookmark">自动化测试实践经验和教训</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				序言:在部门做自动化有好一段时间了,经历了自动化从无到有,然后到框架,到现在的平台,以及持续集成,回顾发现由于自己之前经验太浅,走过的弯路太多,现在也还在谨慎的前进着,上次又回顾了一遍&quot;软件测试经验和教训&quot;里的自动化测试章节,发现早前很多懵懂的经验,现在稍稍清晰,于是想着结合自己的历程精简出一些经验吧.现在经验还是尚浅,如果有更深认识的朋友,互相讨论,谢谢 一.所谓自动化是为了软件发布服务的,并不只是为了测试服务 来源:自动化测试目标建设 以前一直怀疑自动化测试的用处,我们之前花费大力			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2RKv3b.html" rel="bookmark">在中国做了三年企业级 SaaS 的几点心得</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着消费类互联网市场(To C)的格局渐定,越来越多的创业者和资本将目光投向了企业级(To B),&quot;风口猪论&quot; 又起.有人大胆预测:2015年 将是企业级互联网服务的 &quot;元年&quot;,未来几年内,国内企业级领域或迎来大发展的黄金岁月.摸准了,会诞生一批超过 10 亿美金的高价值公司. 从用户的接受度上看,确实可以称之为 &quot;元年&quot;.但瞄准这个市场的先知先觉先行者却大有人在.从 2012年 起,就有一大批企业服务平台涌现,虽然亮出的旗号不尽相同,目标都是一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkA5POb.html" rel="bookmark">企业级SaaS与消费级SaaS有何区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SaaS在企业级市场中举足轻重,但SaaS是否能在消费级服务领域取得成功? 新SaaS公司出现的速度正在放缓,但SaaS这种商业模式依然炙手可热.交付应用程序仍然是软件公司赚钱的首选方式. 在用户流失率可以接受,并且有稳定新客户来源的情况下,随着时间的推移,SaaS公司多半比采用传统模式销售的公司能够获得更多的收入与利润.企业级客户也对这种模式接受度越来越高,这就导致估值最高的SaaS公司们全都把目标放在扩大规模上. 虽然SaaS在企业用户中越来越流行,在消费级用户中是否也会出现类似的趋势?随着			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0Onjp.html" rel="bookmark">企业级SaaS市场暗流涌动 风口之上谁能问鼎2016</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				40亿元,这是中国SaaS市场在2015年交出的融资成绩单.在过去的一年中,这个领域发生了近百起融资事件,SaaS也成为中国资本市场的当红炸子鸡. 据易观报告显示,2015年国内企业级SaaS市场规模将达到199.3亿元人民币,增长率高达69.7%,在企业高效运营管理需求.移动互联网应用条件不断成熟等多方因素推动下,市场规模仍将保持高速增长,预计2016年市场规模将超过300亿元人民币,. 业内人士表示,随着移动互联网.大数据.云计算等应用场景的成熟,企业级服务市场需求正不断增加,而2C市场上资			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvLw5z.html" rel="bookmark" class="title">JavaScript实际应用：子窗口和父窗口交互</a>
					<div>
						javascript|父窗口|交互|子窗口 最近项目开发中需要子窗口和父窗口交互的内容,基本上无非就是把子窗口的信息传递给父窗口,并且关闭自己等等,或者是父窗口把自己的信息传递给子窗口等等. 1.父窗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnPwob.html" rel="bookmark" class="title">用php写的serv-u的web申请账号的程序，很烂，供参考，修改和删除请自己做了！这是个初稿&comma;请多提意见，</a>
					<div>
						serv-u|web|参考|程序 &lt;?//Sign.php//系统适用于win2000//power by devchina.com,http://www.2oa.net$path=&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7d2qb.html" rel="bookmark" class="title">用Visual C&num;实现文件下载</a>
					<div>
						visual|下载 using System; using System.Drawing; using System.Collections; using System.ComponentModel; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw8odb.html" rel="bookmark" class="title">PHP面试题目与基础知识点</a>
					<div>
						PHP软件工程师的面试题 1. 基本知识点 HTTP协议中几个状态码的含义:503 500 401 200 301 302... Include require include_once requir ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze42jNp.html" rel="bookmark" class="title">邻接矩阵无向图&lpar;一&rpar; C语言详解</a>
					<div>
						邻接矩阵无向图的介绍 邻接矩阵无向图是指通过邻接矩阵表示的无向图. 上面的图G1包含了&quot;A,B,C,D,E,F,G&quot;共7个顶点,而且包含了&quot;(A,C),(A,D),(A, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE2Xyb.html" rel="bookmark" class="title">Word入门动画教程136：设置背景</a>
					<div>
						默认情况下,新建的Word文档背景都是单调的白色,如果需要,我们可以按下面的方法为其添加背景 或水印. 执行&quot;格式&quot;→&quot;背景&quot;,选用下列操作之一: 1.在颜色板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW13qez.html" rel="bookmark" class="title">保护好你的Word文档</a>
					<div>
						文档的安全级别 对Word文档最大的安全隐患就是宏病毒,为了防止宏病毒Word设立了安全级别的概念.您可在&quot;工具→选项→&quot;安全性&quot;选项卡→宏安全性&quot;的&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPmEyM.html" rel="bookmark" class="title">双击打不开office软件怎么解决？</a>
					<div>
						  双击打不开office软件怎么解决?           ①双击半天无反应,那么可以在安全模式下启动Word,按下键盘上的Win+R键,输入winword/safe,确定. ②这时就会用安全模式打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RQxrp.html" rel="bookmark" class="title">MySQL表设计优化与索引</a>
					<div>
						  设计好MySql的索引可以让你的数据库飞起来,大大的提高数据库效率.设计MySql索引的时候有一下几点注意: 1.创建索引 对于查询占主要的应用来说,索引显得尤为重要.很多时候性能问题很简单的就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElB1qz.html" rel="bookmark" class="title">解决图解路由无法登陆设置的方法</a>
					<div>
						电话线接猫--猫和猫的自带线接路由器 wan口--自备的网线链接路由器四个口之一和电脑网卡.注意查看电脑IP,为自动.(如果路由器DHCP没有打开,需要手动设电脑IP),做完这些,打开IE,--在地址 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNQQrM.html" rel="bookmark" class="title">台式电脑怎么可以无线上网？</a>
					<div>
						  我们一般的台式机是没有无线接收功能的,所以我们就要给台机安装一个无线接受装置.我们首先的就是无线网卡.无线网卡可以分为内置式和外置式两种,内置式的如下图:(为避免有广告之嫌,我将网卡的品牌做了模糊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywJK8z.html" rel="bookmark" class="title">解决iTunes8&period;2无法连接iPhone方法</a>
					<div>
						  最新版的iTunes 8.2因为加入了屏蔽代码,所以安装后可能会引起一些非苹果官方的软件无法连接到破解后的iPhone和iPod Touch,其实影响连接的文件就是C:Program FilesC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NV9Dz.html" rel="bookmark" class="title">十面埋伏？ 程序世界里的不信任原则</a>
					<div>
						导语 人与人之间最重要的是信任,但程序的世界里,可能信任越少越好;我越发觉得越是高性能高可用的系统里,不信任原则会体现得更加淋漓尽致. 为了少走弯路,写下这篇文章留给自己参考,其中一些是自己踩过的一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmNPkz.html" rel="bookmark" class="title">执行 hadoop jar 命令后没反应了，有人帮看看么</a>
					<div>
						问题描述 hadoop jar /home/tina/TestHadoop.jar com.felix.WordCount /home/tina/hadoop/input /home/tina/had ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7NlWz.html" rel="bookmark" class="title">软件工程缩略词名词解释</a>
					<div>
						问题描述 软件工程缩略词名词解释 DMT SREM SRI CML RTM SCRUM 求大神帮忙解释一下 解决方案 DMT(Dynamic Multithreading Architecture,动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLRLmp.html" rel="bookmark" class="title">提高显示布局文件的性能 3 - 按需载入视图&lpar;ViewStub的使用方法&rpar;</a>
					<div>
						Loading Views On Demand [按需载入视图] 某些时候,我们需要一些很复杂的视图却仅仅很少用到.如果我们在它仅仅需要的时候再载入,这样可以减少内存的使用并且给用户带来流畅的体验.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXvvyz.html" rel="bookmark" class="title">腾讯产品开发中那些鲜为人知的敏捷</a>
					<div>
						腾讯在十几年的成长过程中,给用户带来了很多惊喜和体验,也为自己带来了无数收获,在这其中,敏捷方法功不可没!本文就将为您揭开其中不为人知的敏捷故事. 天生敏捷基因 企鹅出生在极速变化的互联网行业,出生之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeENlb.html" rel="bookmark" class="title">Windows Server 2008 IIS7部署攻略</a>
					<div>
						近日微软的最新服务器操作系统Windows Server 2008已经http://www.aliyun.com/zixun/aggregation/18782.html&quot;&gt;正式发布, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYVnOp.html" rel="bookmark" class="title">制作图表的纯 Js 类库</a>
					<div>
						Highcharts是一个制作图表的纯Javascript类库,主要特性如下: 兼容性:兼容当今所有的浏览器,包括iPhone.IE和火狐等等: 对个人用户完全免费: 纯JS,无BS: 支持大部分的图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBaRgM.html" rel="bookmark" class="title">网站优化的每一天</a>
					<div>
						对于SEOer 最主要的工作做个小结也就是最有利于提升排名的方法 1.文章的原创性,企业站的原创并不难做,可以添加相关的资讯,如果你懒的话,可以百度搜索,然后加以30%的修改,如果做谷歌请对网站的关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YmAVz.html" rel="bookmark" class="title">Entity Framework 4&period;1 Code-First 学习笔记</a>
					<div>
						CodeFirst提供了一种先从代码开始工作,并根据代码直接生成数据库的工作方式.Entity Framework 4.1在你的实体不派生自任何基类.不添加任何特性的时候正常的附加数据库.另外呢,实体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQOdDp.html" rel="bookmark" class="title">Tails 3&period;0 正式发布，不再支持 32 位计算机</a>
					<div>
						基于 Debian 9 (Stretch) 的匿名发行版 Tails 已正式释出 3.0 版. Tails 3.0 不再支持 32 位计算机,只支持 64 位计算机.官方表示这是一个艰难的决定,但只支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0oBvp.html" rel="bookmark" class="title">silverlight调用wcf后无法执行</a>
					<div>
						问题描述 silverlight调用wcf后无法执行 private void LayoutRoot_Loaded(object sender, RoutedEventArgs e) { platfo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBwN3z.html" rel="bookmark" class="title">服务器-怎么办，把linux下的一个文件夹误删了，里面有我写好的脚本文件，好虐心~</a>
					<div>
						问题描述 怎么办,把linux下的一个文件夹误删了,里面有我写好的脚本文件,好虐心~ 我不是root,远程登录服务器在我的的工作目录工作,能不能提供点简单的命令啊?原理我以后再慢慢懂. 解决方案 办法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye7PZM.html" rel="bookmark" class="title">【Qt编程】基于Qt的词典开发系列&amp;amp&semi;lt&semi;六&amp;amp&semi;gt&semi;--界面美化设计</a>
					<div>
						   本文讲一讲界面设计,作品要面向用户,界面设计的好坏直接影响到用户的体验.现在的窗口设计基本都是扁平化的,你可以从window XP与window 8的窗口可以明显感觉出来.当然除了窗口本身的效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z440YNz.html" rel="bookmark" class="title">js中的如何定位固定层的位置&lowbar;javascript技巧</a>
					<div>
						需要获取一些HTML的对象的坐标来更灵活的设置目标层的坐标,这里可以通过用到document.body.scrollTop等属性,但是这些属性在xhtml的标准网页中或更简单的说就是带&lt;!DOC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44031z.html" rel="bookmark" class="title">表格边框的css语法&lowbar;CSS&sol;HTML</a>
					<div>
						我们知道Dreamweaver在表格制作方面做得非常出色,但是在某些时候还是必须结合css才能达到一些特定效果,下面我们先把有关表格边框的css语法整理出来,然后另外介绍怎样用css美化表格的边框.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEPw5z.html" rel="bookmark" class="title">随机头像PHP版&lowbar;php基础</a>
					<div>
						1.  31字节 PHP 随机显示头像 &lt;?readfile(rand(0,5).'.jpg');?&gt; 2.&lt;?php $url='pic';//图片地址,用相对路径 $files= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nl3xb.html" rel="bookmark" class="title">遍历指定目录下的所有目录和文件的php代码&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: &lt;?php function listFiles($path){ $result = array(); foreach(glob($path.'\\'.&quot;*&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0GJ7p.html" rel="bookmark" class="title">《Adobe Flash CS4中文版经典教程》&mdash;&mdash;1&period;13复习</a>
					<div>
						1.13复习 复习题 1．什么是&quot;舞台&quot;? 2．帧与关键帧之间的区别是什么? 3．什么是隐藏的工具,怎样才能访问它们? 4．指出在Flash中用于撤销步骤的两种方法,并进行说明.  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
